C
C
C	PROGRAM NAME:	FORSCRN.FOR
C
C
C	AUTHOR:	THOMAS L.TERRALL
C
C	PURPOSE:	THIS PROGRAM ENABLES THE PROGRAMMMER TO PREPARE
C			THE SCREENS HE WISHES HIS FORTRAN PROGRAMS
C			TO DISPLAY ON THE VT52 CRT WITH THE EDITOR.
C
C	FUNCTION:	THE PROGRAM READS THE DATA FOR THE SCREEN FROM THE
C			INPUT OR EDIT FILE AND MOVES IT TO THE OUTPUT OR
C			SCREEN FILE.  THE SCREEN FILE IS A SEQUENTIALLY
C			ORGANIZED FORMATTED FILE OF FIXED 80 BYTE RECORD
C			LENGTH.
C
C			THIS PROGRAM CREATES IN THE SCREEN FILE LINES OF 80
C			BYTES.  'TAB' CODES ARE REPLACED WITH THE PROPER NUMBER
C			OF SPACES AND LINES OF LESS THAN 80 BYTES ARE FILLED
C			OUT WITH SPACES TO 80 BYTES.
C			NON-PRINTING CHARACTERS OTHER THAN 'TAB' ARE NOT 
C			ALLOWED.
C
C			TWO OPTIONS EXIST FOR THE NUMBER OF LINES IN THE OUTPUT
C			OR SCREEN FILE.  THE PROGRAM HAS TWO MODES.  IN THE
C			'FIXED' MODE THE SCREEN FILE WILL HAVE EXACTLY 24 LINES.
C			IF THE EDIT FILE HAS LESS THAN 24 LINES THE PROGRAM
C			WILL FILL OUT THE SCREEN FILE WITH BLANK LINES.
C			AN EDIT FILE WITH MORE THAN 24 LINES IS REJECTED.
C			IN THE 'VARIABLE' MODE THERE IS NO RESCRICTION ON THE
C			NUMBER OF LINES IN THE SCREEN FILE.  THE SCREEN FILE
C			WILL HAVE THE SAME NUMBER OF LINES AS THE EDIT FILE.
C
C	OPERATION:	THE PROGRAM QUERYS THE USER FOR THE NAMES OF THE
C			INPUT OR EDIT FILE AND THE OUTPUT OR SCREEN FILE.
C			A BLANK INPUT FILE NAME WILL END PROGRAM EXECUTION.
C			THE PROGRAM ALSO QUERYS THE USER FOR THE MODE,
C			'FIXED' OR 'VARIABLE'.
C
C NOTES:		1. COMPILE/LINK
C				$FOR/LIS/CHECK=ALL/NOI4 FORSCRN.FOR
C				$LINK FORSCRN.OBJ
C
C
	INTEGER *2	I,J,RCR_SIZE,K
C
	LOGICAL*1	IN(81),OUT(80)
C
	CHARACTER*4	MODE
	CHARACTER*30	IN_NAME,OUT_NAME
C
C
C	READ INPUT AND OUTPUT FILE NAMES
C
10	TYPE 12
   12	FORMAT(' INPUT FILE NAME(30A)')
	ACCEPT 16,IN_NAME
   16	FORMAT(30A)
	IF(IN_NAME .EQ. ' ') GO TO 900	!END PROGRAM?
C
	TYPE 18
   18	FORMAT(' OUTPUT FILE NAME(30A)')
	ACCEPT 16,OUT_NAME
C
C	OPEN FILES
C
	OPEN(UNIT=80,NAME=IN_NAME,TYPE='OLD',
     1	     ERR=410,ACCESS='SEQUENTIAL',FORM='FORMATTED',
     2       ORGANIZATION='SEQUENTIAL',RECORDTYPE='VARIABLE')
	OPEN(UNIT=82,NAME=OUT_NAME,TYPE='NEW',ERR=420,
     1       ACCESS='SEQUENTIAL',FORM='FORMATTED',
     2       ORGANIZATION='SEQUENTIAL',RECORDTYPE='FIXED',
     3		RECORDSIZE=80)
C
	K=0
C
C	DETERMINE MODE
C
15	TYPE 22
22	FORMAT(' MODE? (FIXED,VARIABLE)')
	ACCEPT 13, MODE
13	FORMAT(4A)
	IF(MODE .EQ. 'FIXE') GO TO 40
	IF(MODE .EQ. 'VARI') GO TO 40
	WRITE(6,*) ' IMPROPER RESPONSE'
	GO TO 15
C
C	READ RECORDS OF INPUT FILE AND WRITE TO OUTPUT FILE
C
C		READ RECORD OF INPUT FILE
40	READ(80,50,ERR=430,END=500)RCR_SIZE,(IN(I),I=1,RCR_SIZE)
50	FORMAT(Q,80A)
	K=K+1	!INCREMENT NUMBER OF RECORDS
	IF(K .LE. 24) GO TO 55
	IF( MODE .EQ. 'FIXE') GO TO 300
55	DO 20 I=1,80	!BLANK OUTPUT LINE
	OUT(I) = ' '
20	CONTINUE
	IF(RCR_SIZE .EQ. 0) GO TO 150	!ZERO LENGTH RECORD?
	J = 0	!INITIALIZE POSITION IN OUTPUT LINE
C
C		TRANSFER LINE FROM IN ARRAY TO OUT ARRAY CHARACTER BY CHARACTER
C
	DO 100 I = 1,RCR_SIZE
C
C			TEST FOR TAB CODE
	IF(IN(I) .NE. 09) GO TO 60	!
	J=J/8*8 + 8	!SET J TO NEXT TAB STOP
	IF(J .GT. 80 ) GO TO 400
	GO TO 100
C
C			TEST FOR NON-PRINTING CHARACTER
60	IF(IN(I) .LT. 32 .OR. IN(I) .GT. 126) GO TO 200
C
C			MOVE CHARACTER
	J=J+1
	IF(J .GT. 80) GO TO 400
	OUT(J) = IN(I)	
100	CONTINUE
C
C		WRITE LINE TO OUTPUT FILE
150	WRITE(82,155,ERR=440) OUT
155	FORMAT(80A)
	GO TO 40
C
C	ERROR MESSAGES
200	WRITE(6,201) K,I
201	FORMAT(' NON-PRINTING CHARACTER FOUND IN LINE-'I4'AND COLUMN-'
	1      I2'-END FILE')
	GO TO 560
C
300	WRITE(6,*) ' MORE THAN 24 LINES IN EDIT FILE - END FILE'
	GO TO 560
C
400	WRITE(6,*) ' OUTPUT RECORD EXCEEDS 80 BYTES - END FILE'
	GO TO 560
410	WRITE(6,*) ' ERROR OPENING INPUT FILE'
	GO TO 10
C
420	WRITE(6,*) ' ERROR OPENING OUTPUT FILE'
	GO TO 570
C
440	WRITE(6,*) ' OUTPUT FILE ACESS ERROR - ABEND'
	GO TO 560
C
430	WRITE(6,*) ' INPUT FILE ACCESS ERROR - ABEND'
	GO TO 560
C
C	END FILE
500	IF(MODE .EQ. 'VARI') GO TO 540
	IF(K .EQ. 24 ) GO TO 540
	DO 512 I = 1,80
	OUT(I) = ' '
512	CONTINUE
C
	DO 520 J = K+1,24
	WRITE(82,155) OUT
520	CONTINUE
540	WRITE(6,*) ' INPUT FILE COMPLETED - END'
	GO TO 550
C
C	CLOSE FILES
550	CLOSE(UNIT=82)
	GO TO 570
560	CLOSE(UNIT=82,DISPOSE='DELETE')
570	CLOSE(UNIT=80)
	GO TO 10
C
C	END PROGRAM
600	CLOSE(UNIT=80)
	CLOSE (UNIT = 82)
900	CALL EXIT
	END
